KDE 4.7 PyKDE API Reference

- KDE's Python API

# KMainWindow Class Reference

`from PyKDE4.kdeui import *`

Inherits: QMainWindow → QWidget → QObject

## Detailed Description

KDE top level main window

Top level widget that provides toolbars, a status line and a frame.

It should be used as a top level (parent-less) widget. It manages the geometry for all its children, including your main widget.

Normally, you will inherit from KMainWindow, then construct (or use some existing) widget as your main view. You can set only one main view.

You can add as many toolbars as you like. There can be only one menubar and only one statusbar.

The toolbars, menubar, and statusbar can be created by the KMainWindow and - unlike the old KMainWindow - may, but do not have to, be deleted by you. KMainWindow will handle that internally.

Height and width can be operated independently from each other. Simply define the minimum/maximum height/width of your main widget and KMainWindow will take this into account. For fixed size windows set your main widget to a fixed size.

Fixed aspect ratios (heightForWidth()) and fixed width widgets are not supported.

KMainWindow will set icon, mini icon and caption, which it gets from KApplication. It provides full session management, and will save its position, geometry and positions of toolbars and menubar on logout. If you want to save additional data, reimplement saveProperties() and (to read them again on next login) readProperties(). To save special data about your data, reimplement saveGlobalProperties(). To warn user that application or windows have unsaved data on close or logout, reimplement queryClose() and/or queryExit().

You have to implement session restoring also in your main() function. There are also kRestoreMainWindows convenience functions which can do this for you and restore all your windows on next login.

Note that KMainWindow uses KGlobal.ref() and KGlobal.deref() so that closing the last mainwindow will quit the application unless there is still something that holds a ref in KGlobal - like a KIO job, or a systray icon.

See also:
  KApplication

Author:
  Reginald Stadlbauer (reggie@kde.org) Stephan Kulow (coolo@kde.org), Matthias Ettrich (ettrich@kde.org), Chris Schlaeger (cs@kde.org), Sven Radej (radej@kde.org). Maintained by David Faure (faure@kde.org)

## Methods
| __init__ (self, QWidget parent=0, Qt::WindowFlags f=0)
| appHelpActivated (self)
| applyMainWindowSettings (self, KConfigGroup config, bool forceGlobal=0)
KConfigGroup | autoSaveConfigGroup (self)
QString | autoSaveGroup (self)
bool | autoSaveSettings (self)
| closeEvent (self, QCloseEvent a0)
KMenu | customHelpMenu (self, bool showWhatsThis=1)
QString | dbusName (self)
bool | event (self, QEvent event)
bool | hasMenuBar (self)
KMenu | helpMenu (self, QString aboutAppText=QString(), bool showWhatsThis=1)
| ignoreInitialGeometry (self)
bool | initialGeometrySet (self)
KMenuBar | menuBar (self)
| parseGeometry (self, bool parsewidth)
bool | queryClose (self)
bool | queryExit (self)
| readGlobalProperties (self, KConfig sessionConfig)
| readProperties (self, KConfigGroup a0)
bool | readPropertiesInternal (self, KConfig a0, int a1)
| resetAutoSaveSettings (self)
bool | restore (self, int number, bool show=1)
| restoreWindowSize (self, KConfigGroup config)
| saveAutoSaveSettings (self)
| saveGlobalProperties (self, KConfig sessionConfig)
| saveMainWindowSettings (self, KConfigGroup config)
| saveProperties (self, KConfigGroup a0)
| savePropertiesInternal (self, KConfig a0, int a1)
| saveWindowSize (self, KConfigGroup config)
| setAutoSaveSettings (self, QString groupName=QLatin1String("MainWindow"), bool saveWindowSize=1)
| setAutoSaveSettings (self, KConfigGroup group, bool saveWindowSize=1)
| setCaption (self, QString caption)
| setCaption (self, QString caption, bool modified)
| setPlainCaption (self, QString caption)
| setSettingsDirty (self)
bool | settingsDirty (self)
| showAboutApplication (self)
KStatusBar | statusBar (self)
KToolBar | toolBar (self, QString name=QString())
[KToolBar] | toolBars (self)
## Static Methods
bool | canBeRestored (int number)
QString | classNameOfToplevel (int number)
[KMainWindow] | memberList ()

## Method Documentation

__init__ | ( | self, |
|  | QWidget | parent=0,
|  | Qt::WindowFlags | f=0
| ) |  |  |

Construct a main window.

Parameters:

  | parent | The widget parent. This is usually 0 but it may also be the window group leader. In that case, the KMainWindow becomes sort of a secondary window.
  | f | Specify the window flags. The default is none.

Note that a KMainWindow per-default is created with the WA_DeleteOnClose attribute, i.e. it is automatically destroyed when the window is closed. If you do not want this behavior, call setAttribute(Qt.WA_DeleteOnClose, false);

KMainWindows must be created on the heap with 'new', like:

     KMainWindow *kmw = new KMainWindow(...);
     kmw->setObjectName(...);

IMPORTANT: For session management and window management to work properly, all main windows in the application should have a different name. If you don't do it, KMainWindow will create a unique name, but it's recommended to explicitly pass a window name that will also describe the type of the window. If there can be several windows of the same type, append '#' (hash) to the name, and KMainWindow will replace it with numbers to make the names unique. For example, for a mail client which has one main window showing the mails and folders, and which can also have one or more windows for composing mails, the name for the folders window should be e.g. "mainwindow" and for the composer windows "composer#".

appHelpActivated | ( |  | self ) |

Open the help page for the application.

The application name is used as a key to determine what to display and the system will attempt to open <appName>/index.html.

This method is intended for use by a help button in the toolbar or components outside the regular help menu. Use helpMenu() when you want to provide access to the help system from the help menu.

Example (adding a help button to the first toolbar):

     toolBar(0)->addAction(KIcon("help-contents"), i18n("Help"),
                           this, SLOT(appHelpActivated()));

applyMainWindowSettings | ( | self, |
|  | KConfigGroup | config,
|  | bool | forceGlobal=0
| ) |  |  |

Read settings for statusbar, menubar and toolbar from their respective groups in the config file and apply them.

Parameters:

  | config | Config group to read the settings from.
  | forceGlobal | see the same argument in KToolBar.applySettings

KConfigGroup autoSaveConfigGroup | ( |  | self ) |

Returns:
  the group used for setting-autosaving. Only meaningful if setAutoSaveSettings() was called. This can be useful for forcing an apply, e.g. after using KEditToolbar.

Since:
  4.1

QString autoSaveGroup | ( |  | self ) |

Returns:
  the group used for setting-autosaving. Only meaningful if setAutoSaveSettings(QString) was called. This can be useful for forcing a save or an apply, e.g. before and after using KEditToolbar.

NOTE: you should rather use saveAutoSaveSettings() for saving or autoSaveConfigGroup() for loading. This method doesn't make sense if setAutoSaveSettings(KConfigGroup) was called.

bool autoSaveSettings | ( |  | self ) |

Returns:
  the current autosave setting, i.e. true if setAutoSaveSettings() was called, false by default or if resetAutoSaveSettings() was called.

closeEvent | ( | self, |
|  | QCloseEvent | a0
| ) |  |  |

Reimplemented to call the queryClose() and queryExit() handlers.

We recommend that you reimplement the handlers rather than closeEvent(). If you do it anyway, ensure to call the base implementation to keep queryExit() running.

KMenu customHelpMenu | ( | self, |
|  | bool | showWhatsThis=1
| ) |  |  |

Returns the help menu. Creates a standard help menu if none exists yet.

It contains entries for the help system (activated by F1), an optional "What's This?" entry (activated by Shift F1), an application specific dialog box, and an "About KDE" dialog box. You must create the application specific dialog box yourself. When the "About application" menu entry is activated, a signal will trigger the showAboutApplication slot. See showAboutApplication for more information.

Example (adding a help menu to your application):

     menuBar()->addMenu( customHelpMenu() );

Parameters:

  | showWhatsThis | Set this to false if you do not want to include the "What's This" menu entry.

Returns:
  A standard help menu.

QString dbusName | ( |  | self ) |

Returns the path under which this window's D-Bus object is exported.

Since:
  4.0.1

bool event | ( | self, |
|  | QEvent | event
| ) |  |  |

Reimplemented to catch QEvent.Polish in order to adjust the object name if needed, once all constructor code for the main window has run. Also reimplemented to catch when a QDockWidget is added or removed.

bool hasMenuBar | ( |  | self ) |

Returns true, if there is a menubar

KMenu helpMenu | ( | self, |
|  | QString | aboutAppText=QString(),
|  | bool | showWhatsThis=1
| ) |  |  |

Retrieve the standard help menu.

It contains entries for the help system (activated by F1), an optional "What's This?" entry (activated by Shift F1), an application specific dialog box, and an "About KDE" dialog box.

Example (adding a standard help menu to your application):

     KMenu *help = helpMenu( <myTextString> );
     menuBar()->addMenu( help );

Parameters:

  | aboutAppText | The string that is used in the application specific dialog box. If you leave this string empty the information in the global KAboutData of the application will be used to make a standard dialog box.
  | showWhatsThis | Set this to false if you do not want to include the "What's This" menu entry.

Returns:
  A standard help menu.

ignoreInitialGeometry | ( |  | self ) |

Internal:
  Used from Konqueror when reusing the main window.

bool initialGeometrySet | ( |  | self ) |

Returns:
  true if a -geometry argument was given on the command line, and this is the first window created (the one on which this option applies)

KMenuBar menuBar | ( |  | self ) |

Returns a pointer to the menu bar.

If there is no menu bar yet one will be created.

parseGeometry | ( | self, |
|  | bool | parsewidth
| ) |  |  |

bool queryClose | ( |  | self ) |

Called before the window is closed, either by the user or indirectly by the session manager.

The purpose of this function is to prepare the window in a way that it is safe to close it, i.e. without the user losing some data.

Default implementation returns true. Returning false will cancel the closing, and, if KApplication.sessionSaving() is true, it will also cancel KDE logout.

Reimplement this function to prevent the user from losing data. Example:

    switch ( KMessageBox.warningYesNoCancel( this,
    i18n("Save changes to document foo?")) ) {
    case KMessageBox.Yes :
    // save document here. If saving fails, return false;
    return true;
    case KMessageBox.No :
    return true;
    default: // cancel
    return false;

Note that you should probably not actually close the document from within this method, as it may be called by the session manager before the session is saved. If the document is closed before the session save occurs, its location might not be properly saved. In addition, the session shutdown may be canceled, in which case the document should remain open.

See also:
  queryExit()

See also:
  KApplication.sessionSaving()

bool queryExit | ( |  | self ) |

Called before the very last window is closed, either by the user or indirectly by the session manager.

It is not recommended to do any user interaction in this function other than indicating severe errors. Better ask the user on queryClose() (see below).

A typical usage of queryExit() is to write configuration data back. Note that the application may continue to run after queryExit() (the user may have canceled a shutdown), so you should not do any cleanups here. The purpose of queryExit() is purely to prepare the application (with possible user interaction) so it can safely be closed later (without user interaction).

If you need to do serious things on exit (like shutting a dial-up connection down), connect to the signal QCoreApplication.aboutToQuit().

Default implementation returns true. Returning false will cancel the exiting. In the latter case, the last window will remain visible. If KApplication.sessionSaving() is true, refusing the exit will also cancel KDE logout.

See also:
  queryClose()

See also:
  KApplication.sessionSaving()

readGlobalProperties | ( | self, |
|  | KConfig | sessionConfig
| ) |  |  |

The counterpart of saveGlobalProperties().

Read the application-specific properties in again.

readProperties | ( | self, |
|  | KConfigGroup | a0
| ) |  |  |

Read your instance-specific properties.

Is called indirectly by restore().

bool readPropertiesInternal | ( | self, |
|  | KConfig | a0,
|  | int | a1
| ) |  |  |

resetAutoSaveSettings | ( |  | self ) |

Disable the auto-save-settings feature. You don't normally need to call this, ever.

bool restore | ( | self, |
|  | int | number,
|  | bool | show=1
| ) |  |  |

Try to restore the toplevel widget as defined by number (1..X).

You should call canBeRestored() first.

If the session did not contain so high a number, the configuration is not changed and false returned.

That means clients could simply do the following:

     if (qApp->isSessionRestored()){
       int n = 1;
       while (KMainWindow.canBeRestored(n)){
         (new childMW)->restore(n);
         n++;
       }
     } else {
       // create default application as usual
     }

Note that if show is true (default), QWidget.show() is called implicitly in restore.

With this you can easily restore all toplevel windows of your application.

If your application uses different kinds of toplevel windows, then you can use KMainWindow.classNameOfToplevel(n) to determine the exact type before calling the childMW constructor in the example from above.

<i>Note that you don't need to deal with this function. Use the kRestoreMainWindows() convenience template function instead!</i>

See also:
  kRestoreMainWindows()

See also:
  #RESTORE

See also:
  readProperties()

See also:
  canBeRestored()

restoreWindowSize | ( | self, |
|  | KConfigGroup | config
| ) |  |  |

For inherited classes Note that a -geometry on the command line has priority.

saveAutoSaveSettings | ( |  | self ) |

This slot should only be called in case you reimplement closeEvent() and if you are using the "auto-save" feature. In all other cases, setSettingsDirty() should be called instead to benefit from the delayed saving.

See also:
  setAutoSaveSettings

See also:
  setSettingsDirty

Example:

     void MyMainWindow.closeEvent( QCloseEvent *e )
     {
       // Save settings if auto-save is enabled, and settings have changed
       if ( settingsDirty() && autoSaveSettings() )
         saveAutoSaveSettings();
       ..
     }

saveGlobalProperties | ( | self, |
|  | KConfig | sessionConfig
| ) |  |  |

Save your application-wide properties. The function is invoked when the session manager requests your application to save its state.

This function is similar to saveProperties() but is only called for the very first main window, regardless how many main window are open.

Override it if you need to save other data about your documents on session end. sessionConfig is a config to which that data should be saved. Normally, you don't need this function. But if you want to save data about your documents that are not in opened windows you might need it.

Default implementation does nothing.

saveMainWindowSettings | ( | self, |
|  | KConfigGroup | config
| ) |  |  |

Save settings for statusbar, menubar and toolbar to their respective groups in the config group config.

Parameters:

  | config | Config group to save the settings to.

saveProperties | ( | self, |
|  | KConfigGroup | a0
| ) |  |  |

Save your instance-specific properties. The function is invoked when the session manager requests your application to save its state.

Please reimplement these function in childclasses.

Note: No user interaction is allowed in this function!

savePropertiesInternal | ( | self, |
|  | KConfig | a0,
|  | int | a1
| ) |  |  |

saveWindowSize | ( | self, |
|  | KConfigGroup | config
| ) |  |  |

For inherited classes

setAutoSaveSettings | ( | self, |
|  | QString | groupName=QLatin1String("MainWindow"),
|  | bool | saveWindowSize=1
| ) |  |  |

Overload that lets you specify a KConfigGroup. This allows the settings to be saved into another file than KGlobal.config().

Since:
  4.1

setAutoSaveSettings | ( | self, |
|  | KConfigGroup | group,
|  | bool | saveWindowSize=1
| ) |  |  |

Overload that lets you specify a KConfigGroup. This allows the settings to be saved into another file than KGlobal.config().

Since:
  4.1

setCaption | ( | self, |
|  | QString | caption
| ) |  |  |

Makes a KDE compliant caption.

Parameters:

  | caption | Your caption. Do not include the application name in this string. It will be added automatically according to the KDE standard.
  | modified | Specify whether the document is modified. This displays an additional sign in the title bar, usually "**".

setCaption | ( | self, |
|  | QString | caption,
|  | bool | modified
| ) |  |  |

Makes a KDE compliant caption.

Parameters:

  | caption | Your caption. Do not include the application name in this string. It will be added automatically according to the KDE standard.
  | modified | Specify whether the document is modified. This displays an additional sign in the title bar, usually "**".

setPlainCaption | ( | self, |
|  | QString | caption
| ) |  |  |

Make a plain caption without any modifications.

Parameters:

  | caption | Your caption. This is the string that will be displayed in the window title.

setSettingsDirty | ( |  | self ) |

Tell the main window that it should save its settings when being closed. This is part of the auto-save-settings feature. For everything related to toolbars this happens automatically, but you have to call setSettingsDirty() in the slot that toggles the visibility of the statusbar.

bool settingsDirty | ( |  | self ) |

For inherited classes

showAboutApplication | ( |  | self ) |

This slot does nothing.

It must be reimplemented if you want to use a custom About Application dialog box. This slot is connected to the About Application entry in the menu returned by customHelpMenu.

Example:

     void MyMainLevel.setupInterface()
     {
       ..
       menuBar()->addMenu( customHelpMenu() );
       ..
     }

     void MyMainLevel.showAboutApplication()
     {
       <activate your custom dialog>
     }

KStatusBar statusBar | ( |  | self ) |

Returns a pointer to the status bar.

If there is no status bar yet, one will be created.

Note that tooltips for kactions in actionCollection() are not automatically connected to this statusBar. See the KActionCollection documentation for more details.

See also:
  KActionCollection

KToolBar toolBar | ( | self, |
|  | QString | name=QString()
| ) |  |  |

Returns a pointer to the toolbar with the specified name. This refers to toolbars created dynamically from the XML UI framework. If the toolbar does not exist one will be created.

Parameters:

  | name | The internal name of the toolbar. If no name is specified "mainToolBar" is assumed.

Returns:
  A pointer to the toolbar

[KToolBar] toolBars | ( |  | self ) |

Returns:
  A list of all toolbars for this window

## Static Method Documentation

bool canBeRestored | ( | int | number
| ) |  |  |

If the session did contain so high a number, true is returned, else false.

See also:
  restore()

QString classNameOfToplevel | ( | int | number
| ) |  |  |

Returns the className() of the number of the toplevel window which should be restored.

This is only useful if your application uses different kinds of toplevel windows.

[KMainWindow] memberList | ( |  | ) |

List of members of KMainWindow class.